--- graph.php-orig	2013-12-03 23:41:30.000000000 -0500
+++ graph.php-improved	2013-12-04 00:54:52.000000000 -0500
@@ -69,24 +69,24 @@
 
 //SVG attributes
 $attribs['axis']='fill="black" stroke="black"';
-$attribs['in']='fill="#FF0000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="7"';
-$attribs['out']='fill="#000000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="7"';
-$attribs['graph_in']='fill="none" stroke="#FF0000" stroke-opacity="0.8"';
-$attribs['graph_out']='fill="none" stroke="#000000" stroke-opacity="0.8"';
-$attribs['legend']='fill="black" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="4"';
-$attribs['graphname']='fill="#FF0000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="8"';
-$attribs['grid_txt']='fill="gray" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="6"';
-$attribs['grid']='stroke="gray" stroke-opacity="0.5"';
-$attribs['switch_unit']='fill="#FF0000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="4" text-decoration="underline"';
-$attribs['switch_scale']='fill="#FF0000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="4" text-decoration="underline"';
-$attribs['error']='fill="blue" font-family="Arial" font-size="4"';
-$attribs['collect_initial']='fill="gray" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="4"';
+$attribs['in']='fill="#FF0000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="32"';
+$attribs['out']='fill="#000000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="32"';
+$attribs['graph_in']='fill="none" stroke="#FF0000" stroke-opacity="0.8" stroke-width="4.5"';
+$attribs['graph_out']='fill="none" stroke="#000000" stroke-opacity="0.8" stroke-width="4.5"';
+$attribs['legend']='fill="black" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="18"';
+$attribs['graphname']='fill="#FF0000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="36"';
+$attribs['grid_txt']='fill="gray" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="26"';
+$attribs['grid']='stroke="gray" stroke-opacity="0.5" stroke-width="4.5"';
+$attribs['switch_unit']='fill="#FF0000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="24" text-decoration="underline"';
+$attribs['switch_scale']='fill="#FF0000" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="24" text-decoration="underline"';
+$attribs['error']='fill="blue" font-family="Arial" font-size="24"';
+$attribs['collect_initial']='fill="gray" font-family="Tahoma, Verdana, Arial, Helvetica, sans-serif" font-size="24"';
 
 //Error text if we cannot fetch data : depends on which method is used
 $error_text = "Cannot get data about interface " . htmlspecialchars($ifnum);
 
-$height=100;            //SVG internal height : do not modify
-$width=200;             //SVG internal width : do not modify
+$height=450;            //SVG internal height : do not modify
+$width=900;             //SVG internal width : do not modify
 
 $fetch_link = "ifstats.php?if=" . htmlspecialchars($ifnum);
 
@@ -109,16 +109,16 @@
     <text id="grid_txt1" x="<?=$width?>" y="<?=$height/4*1?>" <?=$attribs['grid_txt']?> text-anchor="end"> </text>
     <text id="grid_txt2" x="<?=$width?>" y="<?=$height/4*2?>" <?=$attribs['grid_txt']?> text-anchor="end"> </text>
     <text id="grid_txt3" x="<?=$width?>" y="<?=$height/4*3?>" <?=$attribs['grid_txt']?> text-anchor="end"> </text>
-    <text id="graph_in_lbl" x="5" y="8" <?=$attribs['in']?>><?=gettext("In"); ?></text>
-    <text id="graph_out_lbl" x="5" y="16" <?=$attribs['out']?>><?=gettext("Out"); ?></text>
-    <text id="graph_in_txt" x="20" y="8" <?=$attribs['in']?>> </text>
-    <text id="graph_out_txt" x="20" y="16" <?=$attribs['out']?>> </text>
-    <text id="ifname" x="<?=$width?>" y="8" <?=$attribs['graphname']?> text-anchor="end"><?=htmlspecialchars($ifname)?></text>
-    <text id="switch_unit" x="<?=$width*0.55?>" y="5" <?=$attribs['switch_unit']?>><?=gettext("Switch to bytes/s"); ?></text>
-    <text id="switch_scale" x="<?=$width*0.55?>" y="11" <?=$attribs['switch_scale']?>><?=gettext("AutoScale"); ?> (<?=$scale_type?>)</text>
-    <text id="datetime" x="<?=$width*0.33?>" y="5" <?=$attribs['legend']?>> </text>
-    <text id="graphlast" x="<?=$width*0.55?>" y="17" <?=$attribs['legend']?>><?=gettext("Graph shows last"); ?> <?=$time_interval*$nb_plot?> <?=gettext("seconds"); ?></text>
-    <polygon id="axis_arrow_x" <?=$attribs['axis']?> points="<?=($width) . "," . ($height)?> <?=($width-2) . "," . ($height-2)?> <?=($width-2) . "," . $height?>"/>
+    <text id="graph_in_lbl" x="23" y="36" <?=$attribs['in']?>><?=gettext("In"); ?></text>
+    <text id="graph_out_lbl" x="23" y="72" <?=$attribs['out']?>><?=gettext("Out"); ?></text>
+    <text id="graph_in_txt" x="90" y="36" <?=$attribs['in']?>> </text>
+    <text id="graph_out_txt" x="90" y="72" <?=$attribs['out']?>> </text>
+    <text id="ifname" x="<?=$width?>" y="36" <?=$attribs['graphname']?> text-anchor="end"><?=htmlspecialchars($ifname)?></text>
+    <text id="switch_unit" x="<?=$width*0.55?>" y="28" <?=$attribs['switch_unit']?>><?=gettext("Switch to bytes/s"); ?></text>
+    <text id="switch_scale" x="<?=$width*0.55?>" y="60" <?=$attribs['switch_scale']?>><?=gettext("AutoScale"); ?> (<?=$scale_type?>)</text>
+    <text id="datetime" x="<?=$width*0.33?>" y="23" <?=$attribs['legend']?>> </text>
+    <text id="graphlast" x="<?=$width*0.55?>" y="91" <?=$attribs['legend']?>><?=gettext("Graph shows last"); ?> <?=$time_interval*$nb_plot?> <?=gettext("seconds"); ?></text>
+    <polygon id="axis_arrow_x" <?=$attribs['axis']?> points="<?=($width) . "," . ($height)?> <?=($width-9) . "," . ($height-9)?> <?=($width-9) . "," . $height?>"/>
     <text id="error" x="<?=$width*0.5?>" y="<?=$height*0.5?>"  visibility="hidden" <?=$attribs['error']?> text-anchor="middle"><?=$error_text?></text>
     <text id="collect_initial" x="<?=$width*0.5?>" y="<?=$height*0.5?>"  visibility="hidden" <?=$attribs['collect_initial']?> text-anchor="middle"><?=gettext("Collecting initial data, please wait"); ?>...</text>
   </g>