diff --git a/src/usr/local/www/widgets/javascript/thermal_sensors.js b/src/usr/local/www/widgets/javascript/thermal_sensors.js
index ddb9cadb1c099f358be7ea99ad78b232e4c17692..b2c760de74ebe71635ead634910dee724dd1ccaf 100644
--- a/src/usr/local/www/widgets/javascript/thermal_sensors.js
+++ b/src/usr/local/www/widgets/javascript/thermal_sensors.js
@@ -80,6 +80,9 @@ function buildThermalSensorsDataGraph(thermalSensorsData, tsParams, widgetKey) {
 		if (sensorName.indexOf("cpu") > -1) { //check CPU Threshold config settings
 			warningTemp = tsParams.coreWarningTempThreshold;
 			criticalTemp = tsParams.coreCriticalTempThreshold;
+		} else if (sensorName.indexOf("pch") > -1) { //check PCH Threshold config settings
+			warningTemp = tsParams.pchWarningTempThreshold;
+			criticalTemp = tsParams.pchCriticalTempThreshold;			
 		} else { //assuming sensor is for a zone, check Zone Threshold config settings
 			warningTemp = tsParams.zoneWarningTempThreshold;
 			criticalTemp = tsParams.zoneCriticalTempThreshold;
@@ -133,6 +136,9 @@ function updateThermalSensorsDataGraph(thermalSensorsData, tsParams, widgetKey)
 		if (sensorName.indexOf("cpu") > -1) { //check CPU Threshold config settings
 			warningTemp = tsParams.coreWarningTempThreshold;
 			criticalTemp = tsParams.coreCriticalTempThreshold;
+		} else if (sensorName.indexOf("pch") > -1) { //check PCH Threshold config settings
+			warningTemp = tsParams.pchWarningTempThreshold;
+			criticalTemp = tsParams.pchCriticalTempThreshold;			
 		} else { //assuming sensor is for a zone, check Zone Threshold config settings
 			warningTemp = tsParams.zoneWarningTempThreshold;
 			criticalTemp = tsParams.zoneCriticalTempThreshold;
diff --git a/src/usr/local/www/widgets/widgets/thermal_sensors.widget.php b/src/usr/local/www/widgets/widgets/thermal_sensors.widget.php
index 8fd9996dc2ed5254b20005a727fdcfa2b46eea25..5023864ba8fe4bb2806244355951ec84890f6db5 100644
--- a/src/usr/local/www/widgets/widgets/thermal_sensors.widget.php
+++ b/src/usr/local/www/widgets/widgets/thermal_sensors.widget.php
@@ -124,11 +124,14 @@ if ($_POST['widgetkey']) {
 		$_POST["thermal_sensors_widget_zone_critical_threshold"] = floor(($_POST["thermal_sensors_widget_zone_critical_threshold"] - 32) / 1.8);
 		$_POST["thermal_sensors_widget_core_warning_threshold"] = floor(($_POST["thermal_sensors_widget_core_warning_threshold"] - 32) / 1.8);
 		$_POST["thermal_sensors_widget_core_critical_threshold"] = floor(($_POST["thermal_sensors_widget_core_critical_threshold"] - 32) / 1.8);
+		$_POST["thermal_sensors_widget_pch_warning_threshold"] = floor(($_POST["thermal_sensors_widget_pch_warning_threshold"] - 32) / 1.8);
+		$_POST["thermal_sensors_widget_pch_critical_threshold"] = floor(($_POST["thermal_sensors_widget_pch_critical_threshold"] - 32) / 1.8);
 	}
 
 	set_customwidgettitle($user_settings);
 	saveThresholdSettings($user_settings, $_POST, "thermal_sensors_widget_zone_warning_threshold", "thermal_sensors_widget_zone_critical_threshold");
 	saveThresholdSettings($user_settings, $_POST, "thermal_sensors_widget_core_warning_threshold", "thermal_sensors_widget_core_critical_threshold");
+	saveThresholdSettings($user_settings, $_POST, "thermal_sensors_widget_pch_warning_threshold", "thermal_sensors_widget_pch_critical_threshold");
 
 	//handle checkboxes separately
 	saveGraphDisplaySettings($user_settings, $_POST, "thermal_sensors_widget_show_raw_output");
@@ -150,6 +153,8 @@ $thermal_sensors_widget_zoneWarningTempThreshold = getThresholdValueFromConfig($
 $thermal_sensors_widget_zoneCriticalTempThreshold = getThresholdValueFromConfig($user_settings, "thermal_sensors_widget_zone_critical_threshold", DEFAULT_CRITICAL_THRESHOLD, $widgetkey);
 $thermal_sensors_widget_coreWarningTempThreshold = getThresholdValueFromConfig($user_settings, "thermal_sensors_widget_core_warning_threshold", DEFAULT_WARNING_THRESHOLD, $widgetkey);
 $thermal_sensors_widget_coreCriticalTempThreshold = getThresholdValueFromConfig($user_settings, "thermal_sensors_widget_core_critical_threshold", DEFAULT_CRITICAL_THRESHOLD, $widgetkey);
+$thermal_sensors_widget_pchWarningTempThreshold = getThresholdValueFromConfig($user_settings, "thermal_sensors_widget_pch_warning_threshold", DEFAULT_WARNING_THRESHOLD, $widgetkey);
+$thermal_sensors_widget_pchCriticalTempThreshold = getThresholdValueFromConfig($user_settings, "thermal_sensors_widget_pch_critical_threshold", DEFAULT_CRITICAL_THRESHOLD, $widgetkey);
 
 //get display settings from config (apply defaults if missing)
 $thermal_sensors_widget_showRawOutput = getBoolValueFromConfig($user_settings, "thermal_sensors_widget_show_raw_output", false, $widgetkey);
@@ -171,6 +176,8 @@ $thermal_sensors_widget_showFahrenheit = getBoolValueFromConfig($user_settings,
 			zoneCriticalTempThreshold:<?= $thermal_sensors_widget_zoneCriticalTempThreshold; ?>,
 			coreWarningTempThreshold:<?= $thermal_sensors_widget_coreWarningTempThreshold; ?>,
 			coreCriticalTempThreshold:<?= $thermal_sensors_widget_coreCriticalTempThreshold; ?>,
+			pchWarningTempThreshold:<?= $thermal_sensors_widget_pchWarningTempThreshold; ?>,
+			pchCriticalTempThreshold:<?= $thermal_sensors_widget_pchCriticalTempThreshold; ?>,
 			showRawOutput:<?= $thermal_sensors_widget_showRawOutput ? "true" : "false"; ?>,
 			showFullSensorName:<?= $thermal_sensors_widget_showFullSensorName ? "true" : "false"; ?>,
 			pulsateWarning:<?= $thermal_sensors_widget_pulsateWarning ? "true" : "false"; ?>,
@@ -187,6 +194,8 @@ $thermal_sensors_widget_showFahrenheit = getBoolValueFromConfig($user_settings,
 				$("#thermal_sensors_widget_zone_critical_threshold").val(function(){return getFahrenheitValue(this.value);});
 				$("#thermal_sensors_widget_core_warning_threshold").val(function(){return getFahrenheitValue(this.value);});
 				$("#thermal_sensors_widget_core_critical_threshold").val(function(){return getFahrenheitValue(this.value);});
+				$("#thermal_sensors_widget_pch_warning_threshold").val(function(){return getFahrenheitValue(this.value);});
+				$("#thermal_sensors_widget_pch_critical_threshold").val(function(){return getFahrenheitValue(this.value);});
 			} else {
 				$(".thermal_sensors_widget_unit").html('<?=gettext("&deg;C")?>');
 				$(".thermal_sensors_widget_range").html('<?=gettext("(1&ndash;100)")?>');
@@ -194,6 +203,8 @@ $thermal_sensors_widget_showFahrenheit = getBoolValueFromConfig($user_settings,
 				$("#thermal_sensors_widget_zone_critical_threshold").val(function(){return getCelsiusValue(this.value);});
 				$("#thermal_sensors_widget_core_warning_threshold").val(function(){return getCelsiusValue(this.value);});
 				$("#thermal_sensors_widget_core_critical_threshold").val(function(){return getCelsiusValue(this.value);});
+				$("#thermal_sensors_widget_pch_warning_threshold").val(function(){return getCelsiusValue(this.value);});
+				$("#thermal_sensors_widget_pch_critical_threshold").val(function(){return getCelsiusValue(this.value);});
 			}
 		});
 		// --------------------- Centralized widget refresh system ------------------------------
@@ -233,6 +244,8 @@ if ($thermal_sensors_widget_showFahrenheit) {
 	$thermal_sensors_widget_zoneCriticalTempThreshold = ceil($thermal_sensors_widget_zoneCriticalTempThreshold * 1.8 + 32);
 	$thermal_sensors_widget_coreWarningTempThreshold = ceil($thermal_sensors_widget_coreWarningTempThreshold * 1.8 + 32);
 	$thermal_sensors_widget_coreCriticalTempThreshold = ceil($thermal_sensors_widget_coreCriticalTempThreshold * 1.8 + 32);
+	$thermal_sensors_widget_pchWarningTempThreshold = ceil($thermal_sensors_widget_pchWarningTempThreshold * 1.8 + 32);
+	$thermal_sensors_widget_pchCriticalTempThreshold = ceil($thermal_sensors_widget_pchCriticalTempThreshold * 1.8 + 32);
 }
 ?>
 <div style="padding: 5px">
@@ -281,6 +294,20 @@ if ($thermal_sensors_widget_showFahrenheit) {
 			</div>
 		</div>
 
+		<div class="form-group">
+			<label class="col-sm-4 control-label"><?=gettext('PCH Warning')?></label>
+			<div class="col-sm-4">
+				<input type="text" name="thermal_sensors_widget_pch_warning_threshold" id="thermal_sensors_widget_pch_warning_threshold" value="<?= $thermal_sensors_widget_pchWarningTempThreshold; ?>" class="form-control" />
+			</div>
+		</div>
+
+		<div class="form-group">
+			<label class="col-sm-4 control-label"><?=gettext('PCH Critical')?></label>
+			<div class="col-sm-4">
+				<input type="text" name="thermal_sensors_widget_pch_critical_threshold" id="thermal_sensors_widget_pch_critical_threshold" value="<?= $thermal_sensors_widget_pchCriticalTempThreshold; ?>" class="form-control" />
+			</div>
+		</div>
+
 		<div class="form-group">
 			<label class="col-sm-6 control-label"><?=gettext('Display settings:')?></label>
 		</div>